
Base Language - Bug #2292

Fix error handling when unfixed extent passed to fixed extent input parameter   

04/24/2014 04:54 PM - Hynek Cihlar

Status: Closed Start date: 04/24/2014

Priority: Normal Due date:  

Assignee: Hynek Cihlar % Done: 100%

Category:  Estimated time: 0.00 hour

Target version: Cleanup and Stablization for Server

Features

  

billable: No case_num:  

vendor_id: GCD   

Description

Related issues:

Related to Base Language - Bug #2133: fix precision for decimal, dynamic-exte... Closed 01/21/2014 01/27/2014

Related to Base Language - Bug #2293: Fixing an unfixed extent output paramet... Closed 04/24/2014

History

#1 - 04/24/2014 04:59 PM - Hynek Cihlar

The following code sample causes the error message Calling procedure /home/hc/p34141_Untitled8.ped cannot input an indeterminate extent

parameter if the sub-procedure foo /home/hc/p34141_Untitled8.ped parameter

is a fixed size extent. (11421) in Progress but not in P2J.

function foo returns int (input p as int extent 2).

end.

def var k as int extent.

foo(input k).

 

This issue originated in the issue #2133, see the notes 23-26, 28, 30, 32.

#2 - 04/25/2014 03:25 AM - Constantin Asofiei

Some notes here:

1. the /home/hc/p34141_Untitled8.ped is the actual program name, not some special string (i.e. if you save the test in a test1.p file, then this would

be test1.p)

2. foo(input k) converts to a direct Java method call, right? As ControlFlowOps are not involved in this case, we need to validate the parameters -

but unfortunately this can't be done by the BlockManager APIs.  I think the only choice is to convert any function call (for which its definition

includes an extent parameter) to a ControlFlowOps API call, and add this parameter validation case to ControlFlowOps$InternalEntryCaller.valid.

The conversion change I think will be in the convert/user_functions.rules file.

3. double-check if this error is emitted too when internal procedures or external programs are used.
#3 - 04/25/2014 03:11 PM - Greg Shah

- Target version set to Milestone 11

#4 - 07/08/2014 08:13 PM - Hynek Cihlar

This issue is fixed by #2293. Once #2293 is closed, this can be closed with Nofix resolution.

#5 - 07/13/2014 03:34 PM - Hynek Cihlar

Fixed by #2293.

#6 - 07/13/2014 03:35 PM - Hynek Cihlar

- % Done changed from 0 to 100

- Status changed from New to Feedback

#7 - 07/13/2014 05:49 PM - Greg Shah

- Status changed from Feedback to Closed

#8 - 11/16/2016 12:06 PM - Greg Shah

- Target version changed from Milestone 11 to Cleanup and Stablization for Server Features
